#!/usr/bin/perl

#Vampyr`s Corp presents:
# Billing - gettraf
#    
# (C) 2009, Igor Muraviov
# Based on NetBilling, Michael Klimenko
#
# $Revision: 1.0.4 $
#

use DBI;
use Fcntl ':flock'; # import LOCK_* constants
use Time::Local;

# path to procs.pl
require "/Base/provadmin/cgi-bin/admin/procs.pl";

# (1)/(0)  
my $DEBUG = 0;

print "ProvAdmin\ngettraf\n";


##  LOCK-
open(LCKF, ">$gettraflock") || die "Can't open lockfile $gettraflock\n$!\n";
# make exclusive non-blocking lock on lockfile
flock(LCKF, LOCK_NB|LOCK_EX) || die "$gettraflock ,   !\n";

# Connect to the database.
my $dbh = DBI->connect("DBI:mysql:database=$dbname;host=$dbhost",
                           $dbuser, $dbpass,{'RaiseError' => 1});
			   
# Exit if no connection
if ($dbh == undef) { die "Error connecting to database"; }

##    IP 
my @iface_lst; # global
my %iface_id_traf; #        
my %iface_name_id;
my $sth;
eval {$sth = $dbh->prepare("SELECT ID,TRAFID,NAME FROM Iface");$sth->execute();};
if ($@) { log_msg("    IP : $@"); die "    IP : $@"; };
while (my $ref=$sth->fetchrow_hashref()) {
    my $ifnm = $ref->{'NAME'};
    push @iface_lst,$ifnm;
    $iface_id_traf{$ifnm} = $ref->{'TRAFID'};
    $iface_name_id{$ref->{'NAME'}} = $ref->{'ID'};
    #     
    my $i = 0;
    my $sth1 = $dbh->prepare("SELECT ID,IP,Mask,Neg+0 FROM IfAddr WHERE Iface_ID=$ref->{'ID'} ORDER BY Neg DESC");
    $sth1->execute();
    while (my $ref1=$sth1->fetchrow_hashref()) {
	$iface_id_traf{$ifnm}{A}[$i]{IP} = $ref1->{'IP'}+0;
	$iface_id_traf{$ifnm}{A}[$i]{Mask} = $ref1->{'Mask'}+0;
	$iface_id_traf{$ifnm}{A}[$i]{Neg} = $ref1->{'Neg'};
	if ($DEBUG) { print "\t$ref->{'NAME'}:\t".($ref1->{'Neg'}?"!":"")." ".ipnum2str($ref1->{'IP'})."/".ipnum2str($ref1->{'Mask'}).": "; }
	$i++;

    }
    $sth1->finish();
}
$sth->finish(); undef $sth; undef $sth1;


##    IP 
our @ip_lst = (); # global
our %ip_id_from_ip; #        IP
my $sth;
eval {$sth = $dbh->prepare("SELECT ID,Client_ID,IP FROM ClientIP");$sth->execute();};
if ($@) { log_msg("    IP : $@"); die "    IP : $@"; };
while (my $ref=$sth->fetchrow_hashref()) {
    push @ip_lst,$ref->{'IP'};
    $ip_id_from_ip{$ref->{'IP'}} = $ref->{'Client_ID'};
}
$sth->finish(); undef $sth;

##    IP
our @clients_lst = (); # global
our %client_id_from_ip; #        IP
our %client_discount; # 
our %client_macs; #  MAC-  IP-
our %client_rid;
our %client_vpn;
our %client_zone;
our @clients_id = (); # global
our %client_ip_from_id; #        .
my $sth;
eval {$sth = $dbh->prepare("SELECT ID,ZONEID,RID,IP,MAC,Discount,Vlogin,Vpass FROM Client");$sth->execute();};
if ($@) { log_msg("    : $@"); die "    : $@"; };
while (my $ref=$sth->fetchrow_hashref()) {
    push @clients_lst,$ref->{'IP'};
    $client_id_from_ip{$ref->{'IP'}} = $ref->{'ID'};
    $client_discount{$ref->{'IP'}} = $ref->{'Discount'};
    $client_macs{$ref->{'IP'}} = $ref->{'MAC'};
    $client_rid{$ref->{'IP'}} = $ref->{'RID'};
    $client_vpn{$ref->{'IP'}} = $ref->{'Vlogin'}.' '.$ref->{'Vpass'};
    $client_zone{$ref->{'IP'}} = $ref->{'ZONEID'};
    push @clients_id,$ref->{'ID'};
    $client_ip_from_id{$ref->{'ID'}} = $ref->{'IP'};
}
$sth->finish(); undef $sth;
## debug
if ($DEBUG) { 
    print "------------ Clients data from DB\n";
    print "\$#clients_lst = $#clients_lst\n";
    print "\%clients: " . join(" ", (keys %client_id_from_ip)) . "\n";
    print "\%client IDs: " . join(" ", (values %client_id_from_ip)) . "\n";
    print "\%client discounts: " . join(" ", (values %client_discount)) . "\n";
    print "\%client MACs: " . join(" ", (values %client_macs)) . "\n";
}


##        
my %zones; #    : $zones{}{PriceIn}, $zones{}{PriceOut}, $zones{}{A} -  -
my @zoneids; #   ,     OrderNum
eval { $sth = $dbh->prepare("SELECT ID,PriceIn,PriceOut,GIncl FROM Zone ORDER BY OrderNum") };
$sth->execute();
# debug
if ($DEBUG) { print "------------ Loading zones:\n"; }
while (my $ref = $sth->fetchrow_hashref()) {
    my $zoneid = $ref->{'ID'};
    push @zoneids, $zoneid;
    $zones{$zoneid}{PriceIn}=$ref->{'PriceIn'}+0;
    $zones{$zoneid}{PriceOut}=$ref->{'PriceOut'}+0;
    $zones{$zoneid}{GIncl}=$ref->{'GIncl'}+0;
#    print "zones id: $ref->{'ID'}, zoneid = $zoneid\n";
    #     
    my $i = 0;
    my $sth1 = $dbh->prepare("SELECT ID,IP,Mask,Neg+0 FROM Address WHERE Zone_ID=$ref->{'ID'} ORDER BY Neg DESC");
    $sth1->execute();
    while (my $ref1=$sth1->fetchrow_hashref()) {
	$zones{$zoneid}{A}[$i]{IP} = $ref1->{'IP'}+0;
	$zones{$zoneid}{A}[$i]{Mask} = $ref1->{'Mask'}+0;
	$zones{$zoneid}{A}[$i]{Neg} = $ref1->{'Neg'};
	if ($DEBUG) { print "\t$zoneid:\t".($ref1->{'Neg'}?"!":"")." ".ipnum2str($ref1->{'IP'})."/".ipnum2str($ref1->{'Mask'}).": "; }
	#     
	my $sth2 = $dbh->prepare("SELECT PortNum FROM Port WHERE Address_ID=$ref1->{'ID'}");
	$sth2->execute();
	@{$zones{$zoneid}{A}[$i]{Ports}} = ();
	while (my $ref2=$sth2->fetchrow_hashref()) {
	    if ($DEBUG) { print "$ref2->{'PortNum'} "; }
	    push @{$zones{$zoneid}{A}[$i]{Ports}}, $ref2->{'PortNum'};
	}
	$sth2->finish();
	$i++;
	if ($DEBUG) { print "(".(($#{$zones{$zoneid}{A}[$i-1]{Ports}})+1) . " ports)\n"; }
    }
    $sth1->finish();
}
$sth->finish(); undef $sth;

##    
my %total_inb; my %total_outb;
my %if_inb; my %if_outb;

(my $sec,my $min,my $hour,my $mday,my $mon,my $year,my $wday,my $yday,my $isdst) = localtime(time);
$mon++;
$year += 1900;

($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(timelocal($sec, $min, $hour, $mday, $mon-1, $year)-3600);
$mon++;
$year += 1900;
$mons = sprintf("%02d", $mon);
$mdays = sprintf("%02d", $mday);
$hours = sprintf("%02d", $hour);
$netflowout=$netflowout.'/'.$year.'/'.$year.'-'.$mons.'/'."ft-v05.".$year.'-'.$mons.'-'.$mdays.'.'.$hours."0000+0300";

my $client_ip;
print "Path: $netflowout \n ";  

open (F, $netflowout) or print "Can't open $netflowout !\n";
while (<F>) {
    chomp;
    if (/^(\d)(\d)(\d+)\.\d+\:\d+\:\d+\.\d+\s+\d+\.\d+\:\d+\:\d+\.\d+\s+(\d+)\s+(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\s+(\d+)\s+(\d+)\s+(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})\s+(\d+)\s+\d+\s+\d+\s+\d+\s+(\d+)/) {
	my $m1 = $1; my $m2 = $2; my $dayn = $3; my $srcif = $4; $srcip = $5; my $srcport = $6; my $dstif = $7; my $dstip = $8; my $dstport = $9; my $size = $10;
	my $monn = $m1.$m2;
	$monn+=0;
	if ( $dayn == 31 && $monn == 12 && $mon == 1 && $day == 1 )
	    {
	    $dayn = $day; $monn = $mon;
	    }
	# debug
	if ($DEBUG) { print ">> read line: $srcip:$srcport > $dstip:$dstport, $size bytes\n"; }
	#      ,  ,    
	my $clip = is_client_ip($srcip);
	if (is_iface($srcif, $dstip)) {
	    $if_outb{$srcif}{$monn} += $size;
	    }
	if (is_iface($dstif, $srcip)) {
	    $if_inb{$dstif}{$monn} += $size;
	    }
	if ($clip >= 0) { #    
	    if ($clip == 0) { $client_ip = $srcip };
	    if ($clip > 0) { $client_ip = $client_ip_from_id{$clip} };
    	    if ($DEBUG) { print "         It is outbound\n"; }
	    my $zid = $client_zone{$client_ip};
	    if (ip_in_zone($dstip, $dstport, $zid)) {
		#    ,     
		$total_outb{$client_ip}{$zid}{$monn}{$dayn} += $size;
		}
	}
	my $clip = is_client_ip($dstip);
	if ($clip >= 0) { #    
	    if ($clip == 0) { $client_ip = $dstip };
	    if ($clip > 0) { $client_ip = $client_ip_from_id{$clip} };
    	    if ($DEBUG) { print "         It is inbound\n"; }
	    #      ,  
	    my $zid = $client_zone{$client_ip};
	    if (ip_in_zone($srcip,$srcport,$zid)) {
		#    ,     
		$total_inb{$client_ip}{$zid}{$monn}{$dayn} += $size;
		}
	}
    }
}
close(F);

#      
my $ifn;
my $traffics;
foreach $ifn (keys %if_inb) 
    {
    foreach $mn (keys %{$if_inb{$ifn}})
	{
	#      (  )
	$traffics = $if_inb{$ifn}{$mn}; # / $bytesinkb / $bytesinkb;
        eval {
    	    my $sth = $dbh->prepare("SELECT Iface_ID FROM IfTraf WHERE Iface_ID=$iface_name_id{$ifn} AND Year=YEAR(NOW()) AND Month=$mn");
	$sth->execute();
	if ($sth->rows <= 0) {$dbh->do("INSERT INTO IfTraf (Iface_ID,Year,Month) VALUES ($iface_name_id{$ifn},YEAR(NOW()),$mn)") };
	    $sth->finish();
	};
    eval { $dbh->do("UPDATE IfTraf SET Inbound=Inbound+$traffics WHERE Iface_ID=$iface_name_id{$ifn} AND Month=$mn AND Year=YEAR(NOW())") };
	if ($@) { log_msg("      : $@"); die "      : $@"; }
    }
}
#      
foreach $ifn (keys %if_outb)
    {
    foreach $mn (keys %{$if_outb{$ifn}})
	{
	#      (  )
	$traffics = $if_outb{$ifn}{$mn}; # / $bytesinkb / $bytesinkb;
	eval {
    	    my $sth = $dbh->prepare("SELECT Iface_ID FROM IfTraf WHERE Iface_ID=$iface_name_id{$ifn} AND Year=YEAR(NOW()) AND Month=$mn");
	$sth->execute();
	if ($sth->rows <= 0) {$dbh->do("INSERT INTO IfTraf (Iface_ID,Year,Month) VALUES ($iface_name_id{$ifn},YEAR(NOW()),$mn") };
	    $sth->finish();
	};
    eval { $dbh->do("UPDATE IfTraf SET Outbound=Outbound+$traffics WHERE Iface_ID=$iface_name_id{$ifn} AND Month=$mn AND Year=YEAR(NOW())") };
	if ($@) { log_msg("      : $@"); die "      : $@"; }
    }
}


print "Put traffic and its price into database\n";
##         
##       
my @deactivate_lst = (); #  ,   
foreach $client (keys %total_inb) {
    my $client_costin = 0; #      (   )
    foreach $zid (keys %{$total_inb{$client}}) {
	foreach $mid (keys %{$total_inb{$client}{$zid}}) {
	    foreach $did (keys %{$total_inb{$client}{$zid}{$mid}}) {
		#      (  )
		eval {
		    my $sth = $dbh->prepare("SELECT Client_ID FROM Traffic WHERE Client_ID=$client_id_from_ip{$client} AND Zone_ID=$zid AND Year=YEAR(NOW()) AND Month=$mid AND Day=$did");
		    $sth->execute();
		    if ($sth->rows <= 0) {$dbh->do("INSERT INTO Traffic (Client_ID,Zone_ID,Year,Month,Day) VALUES ($client_id_from_ip{$client},$zid,YEAR(NOW()),$mid,$did)") };
		    $sth->finish();
		    };
		#     
		if ( $zones{$zid}{GIncl} == 0 )
		    {
		    my $costin = ($total_inb{$client}{$zid}{$mid}{$did} / $bytesinkb / $bytesinkb) * $zones{$zid}{PriceIn};
		    $costin *= 1-$client_discount{$client}/100; #  
		    $client_costin += $costin;
		    #    
		    eval { $dbh->do("UPDATE Traffic SET Inbound=Inbound+$total_inb{$client}{$zid}{$mid}{$did},CostIn=CostIn+$costin  WHERE Client_ID=$client_id_from_ip{$client} AND Zone_ID=$zid AND Day=$did AND Month=$mid AND Year=YEAR(NOW())") };
		    if ($@) { log_msg("      : $@"); die "      : $@"; }
		    }
		else
		    {
		    my $fullinb = 0; my $newcost; my $Gi;
		    my $sth23 = $dbh->prepare("SELECT Inbound FROM Traffic WHERE Client_ID=$client_id_from_ip{$client} AND Zone_ID=$zid AND Month=$mid AND Year=YEAR(NOW())"); $sth23->execute();
		    if ($@) { log_msg("      : $@"); die "      : $@"; }
		    while ( my $ref23=$sth23->fetchrow_hashref())
			{ $fullinb += $ref23->{'Inbound'}; }
		    $sth23->finish(); undef $sth23; undef $ref23;
		    $fullinb += $total_inb{$client}{$zid}{$mid}{$did};
		    $Gi = $zones{$zid}{GIncl} * $bytesinkb * $bytesinkb * $bytesinkb;
		    if ( $fullinb > $Gi )
			{
			if ( $fullinb - $Gi < $total_inb{$client}{$zid}{$mid}{$did} )
			    { $newcost = $fullinb - $Gi; }
			else
			    { $newcost = $total_inb{$client}{$zid}{$mid}{$did}; }
			my $costin = ($newcost / $bytesinkb / $bytesinkb) * $zones{$zid}{PriceIn};
			$costin *= 1-$client_discount{$client}/100; #  
			$client_costin += $costin;
			#    
			eval { $dbh->do("UPDATE Traffic SET Inbound=Inbound+$total_inb{$client}{$zid}{$mid}{$did},CostIn=CostIn+$costin  WHERE Client_ID=$client_id_from_ip{$client} AND Zone_ID=$zid AND Day=$did AND Month=$mid AND Year=YEAR(NOW())") };
			if ($@) { log_msg("      : $@"); die "      : $@"; }
			}
		    else
			{
			my $costin = 0;
			$costin *= 1-$client_discount{$client}/100; #  
			$client_costin += $costin;
			#    
			eval { $dbh->do("UPDATE Traffic SET Inbound=Inbound+$total_inb{$client}{$zid}{$mid}{$did},CostIn=CostIn+$costin  WHERE Client_ID=$client_id_from_ip{$client} AND Zone_ID=$zid AND Day=$did AND Month=$mid AND Year=YEAR(NOW())") };
			if ($@) { log_msg("      : $@"); die "      : $@"; }
			}
		    }
	    }
	}
    }
    #     ,     >0
    if ( $client_costin > 0 ) {
        eval { $sth = $dbh->prepare("SELECT Credit,CanCredit+0 as CanCredit FROM Client WHERE ID=$client_id_from_ip{$client}"); };
	$sth->execute();
	my $ref2=$sth->fetchrow_hashref();
        my $newcredit = $ref2->{'Credit'} - $client_costin;
        my $cancredit = $ref2->{'CanCredit'};
	$sth->finish();
        my $deact_sql = ''; #   ,   . SQL-
	if ($newcredit < 0 && !$cancredit)
	    {$deact_sql = ', Active=0 '; push @deactivate_lst,$client; } # 
        eval { $dbh->do("UPDATE Client SET Credit=$newcredit $deact_sql WHERE ID=$client_id_from_ip{$client}") };
	if ($@) { log_msg("          : $@"); }
    }
}
foreach $client (keys %total_outb) {
    my $client_costout = 0; #      (   )
    foreach $zid (keys %{$total_outb{$client}}) 
	{
	foreach $mid (keys %{$total_outb{$client}{$zid}}) 
	    {
	    foreach $did (keys %{$total_outb{$client}{$zid}{$mid}}) 
		{
		#      (  )
		eval {
		my $sth = $dbh->prepare("SELECT Client_ID FROM Traffic WHERE Client_ID=$client_id_from_ip{$client} AND Zone_ID=$zid AND Year=YEAR(NOW()) AND Month=$mid AND Day=$did");
		$sth->execute();
		if ($sth->rows <= 0) {$dbh->do("INSERT INTO Traffic (Client_ID,Zone_ID,Year,Month,Day) VALUES ($client_id_from_ip{$client},$zid,YEAR(NOW()),$mid,$did)") };
		    $sth->finish();
		    };
		#     
		if ( $zones{$zid}{GIncl} == 0 )
		    {
		    my $costout = ($total_outb{$client}{$zid}{$mid}{$did} / $bytesinkb / $bytesinkb) * $zones{$zid}{PriceOut};
		    $costout *= 1-$client_discount{$client}/100; #  
		    $client_costout += $costout;
		    #    
		    eval { $dbh->do("UPDATE Traffic SET Outbound=Outbound+$total_outb{$client}{$zid}{$mid}{$did},CostOut=CostOut+$costout  WHERE Client_ID=$client_id_from_ip{$client} AND Zone_ID=$zid AND Day=$did AND Month=$mid AND Year=YEAR(NOW())") };
		    if ($@) { log_msg("      : $@"); die "      : $@"; }
		    }
		else
		    {
		    my $fulloutb = 0; my $newcost; my $Gi;
		    my $sth23 = $dbh->prepare("SELECT Outbound FROM Traffic WHERE Client_ID=$client_id_from_ip{$client} AND Zone_ID=$zid AND Month=$mid AND Year=YEAR(NOW())"); $sth23->execute();
		    if ($@) { log_msg("      : $@"); die "      : $@"; }
		    while ( my $ref23 = $sth23->fetchrow_hashref())
			{ $fulloutb += $ref23->{'Outbound'}; }
		    $sth23->finish(); undef $sth23; undef $ref23;
		    $fulloutb += $total_outb{$client}{$zid}{$mid}{$did};
		    $Gi = $zones{$zid}{GIncl} * $bytesinkb * $bytesinkb * $bytesinkb;
		    if ( $fulloutb > $Gi )
			{
			if ( $fulloutb - $Gi < $total_outb{$client}{$zid}{$mid}{$did} )
			    { $newcost = $fulloutb - $Gi; }
			else
			    { $newcost = $total_outb{$client}{$zid}{$mid}{$did}; }
			my $costout = ($newcost / $bytesinkb / $bytesinkb) * $zones{$zid}{PriceOut};
			$costout *= 1-$client_discount{$client}/100; #  
			$client_costout += $costout;
			#    
			eval { $dbh->do("UPDATE Traffic SET Outbound=outbound+$total_outb{$client}{$zid}{$mid}{$did},CostOut=CostOut+$costout  WHERE Client_ID=$client_id_from_ip{$client} AND Zone_ID=$zid AND Day=$did AND Month=$mid AND Year=YEAR(NOW())") };
			if ($@) { log_msg("      : $@"); die "      : $@"; }
			}
		    else
			{
			my $costout = 0;
			$costout *= 1-$client_discount{$client}/100; #  
			$client_costout += $costout;
			#    
			eval { $dbh->do("UPDATE Traffic SET Outbound=Outbound+$total_outb{$client}{$zid}{$mid}{$did},CostOut=CostOut+$costout  WHERE Client_ID=$client_id_from_ip{$client} AND Zone_ID=$zid AND Day=$did AND Month=$mid AND Year=YEAR(NOW())") };
			if ($@) { log_msg("      : $@"); die "      : $@"; }
			}
		    }
		}
	    }
    }
    #     ,     >0
    if ( $client_costout > 0 ) {
        eval { $sth = $dbh->prepare("SELECT Credit,CanCredit+0 as CanCredit FROM Client WHERE ID=$client_id_from_ip{$client}"); };
	$sth->execute();
        my $ref2 = $sth->fetchrow_hashref();
	my $newcredit = $ref2->{'Credit'} - $client_costout;
        my $cancredit = $ref2->{'CanCredit'};
	$sth->finish();
        my $deact_sql = ''; #   ,   .  SQL-
	if ($newcredit < 0 && !$cancredit)
	    {$deact_sql = ', Active=0 '; push @deactivate_lst,$client;} # 
        eval { $dbh->do("UPDATE Client SET Credit=$newcredit $deact_sql WHERE ID=$client_id_from_ip{$client}") };
	if ($@) { log_msg("          : $@"); }
    }
}


print "Check, if some clients are to be deactivated\n";
##  
#       
my @deactive_lst = sort @deactivate_lst;
my @dl = ();
#  ,    
$#deactive_lst++; #    ( !)
for (my $i=0; $i<=$#deactive_lst; $i++) {
    if ($deactive_lst[$i] ne $deactive_lst[$i+1])  {push @dl,$deactive_lst[$i];}
}
if ( $i > 0 )
    {
    my %routes;
    my @routeids;
    eval { $sth3 = $dbh->prepare("SELECT * FROM Routers ORDER BY Name") };
    $sth3->execute();
    while (my $ref3 = $sth3->fetchrow_hashref()) 
	{
        my $routeid = $ref3->{'ID'};
	push @routeids, $routeid;
	$routes{$routeid}{Name}=$ref3->{'Name'};
	$routes{$routeid}{Script}=$ref3->{'Script'};
	$routes{$routeid}{IP}=$ref3->{'IP'};
	}
    $sth3->finish(); undef $sth3; undef $ref3;
    }
foreach $cip (@dl) {
    #      
    log_user_event($dbh, $client_id_from_ip{$cip}, "  -  ");
    #  
    my $cmd = `$routes{$client_rid{$cip}}{Script} 998 $cip 1 1 1 1 1 1 $routes{$client_rid{$cip}}{IP} $client_vpn{$cip}`;
    print "  Deactivating $cip: $cmd\n";
    log_msg("Exec $1");
}

$dbh->disconnect();

print "Done!\n\n";

##  LOCK-
flock(LCKF, LOCK_UN);
##  LOCK-
close(LCKF);
##  LOCK-
unlink($gettraflock);

exit;

##################################################			   

#   
sub is_iface($$)
{
    (my $if, my $ip) = @_;
#    $ip = shift;
#print "$i -> $if !!! @iface_lst\n";
    if ($DEBUG) { print "--- CALL is_iface($if),\t\$#iface_lst = $#iface_lst\n"; }
    if ($#iface_lst < 0) {return 0;} #  !
    my $res = 0;
#    foreach $i (@iface_lst) {

#	if ($i eq $if) {
	    #     
	    for ($i=0; $i<=$#{$iface_id_traf{$if}{A}}; $i++) {
		my $adr_hash = \%{$iface_id_traf{$if}{A}[$i]};
	        my $a_ip = $$adr_hash{'IP'}; my $a_msk = $$adr_hash{'Mask'}; my $a_neg = $$adr_hash{'Neg'}+0; my $a_ports_ref = \@{$$adr_hash{'Ports'}};
    		#     
    		if ( (($a_ip & $a_msk) == ($ip & $a_msk)) )#  
		    {
		    if ($a_neg) { #     
			$res = 0; #      
			}
		    else {
			$res = 1;
			}
		    }
#		}
#	    }
	}

    if ($DEBUG) { print "         iface $if not found in \@iface_lst\n"; }
    return $res;
}


# ,   IP- 
sub is_client_ip($)
{
    my $ip = shift @_;
    if ($DEBUG) { print "--- CALL is_client_ip($ip),\t\$#clients_lst = $#clients_lst\n"; }
    if ($#clients_lst < 0) {return -1;} #  !

    foreach $i (@clients_lst) {
	if ($i eq $ip) {return 0;}
    }
    if ($#ip_lst < 0) {return -1;} #  !
    foreach $i (@ip_lst) {
	if ($i eq $ip) {return $ip_id_from_ip{$i};}
    }

    if ($DEBUG) { print "         Client $ip not found in \@clients_lst\n"; }
    return -1;
}

#    ,   -- %zones
sub ip_in_zone($$$)
{
    (my $str_ip, my $port, my $zoneid) = @_;
    #    
    my $ip = ipstr2num($str_ip)+0;
    #  ,      
    my $res = 0;
    # debug
    if ($DEBUG) { print "--- CALL ip_in_zone($str_ip, $port, $zoneid) -> "; }
    #     
    for ($i=0; $i<=$#{$zones{$zoneid}{A}}; $i++) {
	my $adr_hash = \%{$zones{$zoneid}{A}[$i]};
        my $a_ip = $$adr_hash{'IP'}; my $a_msk = $$adr_hash{'Mask'}; my $a_neg = $$adr_hash{'Neg'}+0; my $a_ports_ref = \@{$$adr_hash{'Ports'}};
        #     
        if ( (($a_ip & $a_msk) == ($ip & $a_msk)) && #  
              (is_exist($a_ports_ref, $port)) )     #   
	{
	    if ($a_neg) { #     
		$res = 0; #      
	    } else {
		$res = 1;
	    }
	}
    }
    # debug
    if ($DEBUG) { print "IP is " . ($res ? "" : "not ") . "in zone $zoneid\n"; }
    
    return $res;									  												      
}

#      (  )
sub is_exist($$)
{
    (my $arrayref, my $elem) = @_;
    #   , ,     
    if ($#{@$arrayref} == -1) { return 1; }
    foreach $e (@$arrayref) {
	if ($e eq $elem) { return 1; }
    }
    return 0;
}
