#!/usr/bin/perl


# NetBilling - log
#
# (C) 2003-2006, Michael Klimenko
#
# $Revision: 2.3 $
#

use DBI;
use CGI;

require "./procs.pl";

$scriptpath=$spath_log;
my $co = new CGI;

# Connect to the database.
my $dbh = DBI->connect("DBI:mysql:database=$dbname;host=$dbhost",
                           $dbuser, $dbpass,{'RaiseError' => 1});

if ($dbh == undef) { print "Error connecting to database"; exit(-1); }

html_start($lang{LOG_TITLE});

check_referer();
my $userstatus = -1;
$userstatus = usercheck($dbh, $co->param('user'));
if (  $userstatus < 0 || $co->param('user') eq '')
    {
    print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0;URL=/admin/index.html\">\n";
    $dbh->disconnect();
    exit;
    }

our %client_name_from_id;
my $sth;
eval {$sth = $dbh->prepare("SELECT ID,NAME FROM Client");$sth->execute();};
if ($@) { log_msg("ERROR: $@"); die "ERROR: $@"; };
while (my $ref=$sth->fetchrow_hashref())
    { $client_name_from_id{$ref->{'ID'}} = $ref->{'NAME'}; }
$sth->finish(); undef $sth;


print_navmenu($co->param('user'), $userstatus);


print "<DIV align=center><h1>$orgtitle</h1><h2>$lang{LOG_HEAD}</h2></DIV><br>\n";

# get events of current month by default
my $null;
($null,$null,$null,$null,my $month,my $year,$null,$null,$null) = localtime(time);
$month++; $year+=1900;

if ( ($co->param('Action') eq 'arch') && (defined $co->param('M')) && (defined $co->param('Y')) )  {
    #  
    $month = $co->param('M'); $year = $co->param('Y');
}
    my $orderby;
    if (defined $co->param('orderby')) {$orderby = $co->param('orderby') } else {$orderby='EventTime'}
    print "<TABLE width=100% align=center><TR valign=top align=center><TD>\n";
    get_logslist($month,$year,$orderby);
    print "</TD>\n<TD>";
    get_logsarch();
    print "</TD></TR></TABLE><br>\n";

$dbh->disconnect();
html_end();

exit;

##########################################

#      
sub get_logslist($$$)
{
    (my $month, my $year, my $orderby) = @_;
    my $sth;
    my $clinfo;
    eval { $sth = $dbh->prepare("SELECT L.* FROM Log L WHERE MONTH(L.EventTime)=$month AND YEAR(L.EventTime)=$year ORDER BY $orderby");$sth->execute();};
    if ($@) { print "<FONT color=red>$lang{GENERAL_ERROR_SHORT} $@</FONT><br>";}
    print "<DIV align=center><h3>".sprintf($lang{LOG_REPORT_HEAD},$monthnames[$month],$year)."</h3></DIV>\n";
    print "<TABLE border=1 align=center  cellspacing=0 align=center class=btbl>\n";
    print "<TR style='background-color:#4fafaf'><TH TITLE='$lang{LOG_REPORT_SORT_TIME}' class=btbl><A href=$scriptpath?Action=arch&M=$month&Y=$year&user=".$co->param('user')." class=atbl>$lang{LOG_REPORT_TIME}</A></TH><TH TITLE='$lang{LOG_REPORT_SORT_CLIENT}' class=btbl><A href=$scriptpath?Action=arch&M=$month&Y=$year&orderby=IP&user=".$co->param('user')." class=atbl>$lang{LOG_REPORT_CLIENT}</A></TH><TH class=btbl>$lang{LOG_REPORT_EVENT}</TH></TR>\n";
    while (my $ref = $sth->fetchrow_hashref())
	{
	my $date = $ref->{'EventTime'}; $date =~ s/\s/\&nbsp;/g;
	
	if ( $ref->{'Client_ID'} != 0 )
	    { $clinfo = $client_name_from_id{$ref->{'Client_ID'}}; }
	else
	    { $clinfo = '<font color=red>SyStem</font>'; }
	print "<TR style='background-color:#efef9f'><TD class=btbl>$date</TD><TD class=btbl><A href=$spath_clients?Action=show&ID=$ref->{'Client_ID'}&user=".$co->param('user')." class=atbl>$clinfo</A></TD><TD class=btbl>$ref->{'Msg'}</TD></TR>\n";
	}
    $sth->finish();
    print "</TABLE>\n";
}

#   
sub get_logsarch($$)
{
    (my $month, my $year) = @_;
    my $sth;
    eval { $sth = $dbh->prepare("SELECT DISTINCT CONCAT(MONTH(EventTime),\".\",YEAR(EventTime)) date  FROM Log ORDER BY EventTime");$sth->execute();};
    if ($@) { print "<FONT color=red>$lang{GENERAL_ERROR_SHORT} $@</FONT><br>";}
    print "<DIV align=center><h3>$lang{LOG_ARCH_HEAD}</h3></DIV>\n";
    print "<TABLE border=1 align=center cellpadding=2 cellspacing=0 align=center class=btbl>\n";
    print "<TR style='background-color:#efef9f'>";
    my $dcount = 1;
    while (my $ref = $sth->fetchrow_hashref()) {
	$ref->{'date'} =~ /^(\d{1,2})\.(\d+)$/;
	my $m = $1; my $y = $2;
	my $date = sprintf "%02d.%d",$m,$y;
	print "<TD class=btbl><A href=$scriptpath?Action=arch&M=$m&Y=$y&user=".$co->param('user')." class=atbl>$date</A></TD>\n";
	if ($dcount % 2 == 0) {print "</TR>\n<TR style='background-color:#efef9f'>";}
	$dcount++;
    }
    $sth->finish();
    print "</TABLE>\n";
}
